#ifndef _MYSTDIO_H_
#define _MYSTDIO_H_

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

extern int stdio_InitFATFS (void);
extern int stdio_FlushFATFS (void);
extern int stdio_DoneFATFS (void);

extern long _fsize (FILE* stream);

#ifdef feof
  #undef feof
#endif
extern int feof (FILE* stream);

#ifdef remove
  #undef remove
#endif
extern int remove (const char* filename);

#if !defined(__TURBOC__) || !defined(__WATCOMC__)
// flushall() and fcloseall() don't seem to be the standard ones,
// ANSI/IEC C99 standard, Single UNIX Spec V3 and GCC don't think so:
extern int flushall (void);
extern int fcloseall (void);
#endif

#if defined(__TURBOC__) && (__TURBOC__ <= 0x0296)
// nonstandard _dos_getdrive() and _dos_setdrive() don't
// exist in Turbo C++ 1.01 and lower:
extern void _dos_getdrive (unsigned* drive);
extern void _dos_setdrive (unsigned drive, unsigned* ndrives);
#endif

#if defined(__WATCOMC__)
// nonstandard getdisk() and setdisk() don't exist in <Open> Watcom C/C++:
extern int getdisk (void);
extern int setdisk (int disk);
#endif

#ifdef __cplusplus
}
#endif

#endif // _MYSTDIO_H_
