#include <stddef.h>
#include <stdio.h>

static unsigned LCM (unsigned x, unsigned y)
{
  unsigned t = x;
  if (x < y) { x = y; y = t; t = x; }
  while (x % y) x += t;
  return x;
}

size_t MinAlignmentForMalloc (void)
{
  const unsigned aMainTypesSizes[]=
  {
    sizeof (short),
    sizeof (int),
    sizeof (long),
#if defined(__DJGPP__)
    sizeof (long long),
#endif
    sizeof (void*),
    sizeof (void(*)()),
    sizeof (float),
    sizeof (double),
    sizeof (long double)
  };
  unsigned res = sizeof (char), i;

  for (i=0; i<sizeof(aMainTypesSizes)/sizeof(aMainTypesSizes[0]); i++)
    res = LCM (res, aMainTypesSizes[i]);

  return res;
}

int main()
{
  printf ("minimum address alignment for malloc() should be %u chars\n",
          (unsigned)MinAlignmentForMalloc());
  return 0;
}
