#include <stddef.h>

char* strtok (char* s, const char* delimeters)
{
  const char* p2;
  char c1, c2;
  char* p1;
  static char* last = NULL; // this is not a thread-safe/reentrant function

  // return NULL if the entire string has been searched already
  if ((s == NULL) && ((s = last) == NULL))
    return NULL;

  // skip leading delimiters
l:
  c1 = *s++;
  for (p2 = delimeters; (c2 = *p2++) != 0;)
    if (c1 == c2)
      goto l;
  // s points to character following the 1st non-delimiter

  if (!c1)
  {
    // the entire string has been searched, no non-delimiters were found
    last = NULL;
    return NULL;
  }

  p1 = s - 1;
  // p1 points to the 1st non-delimiter, p1 will be eventually returned

  // scan what follows the 1st non-delimiter
  for (;;)
  {
    c1 = *s++;
    p2 = delimeters;
    do
    {
      if ((c2 = *p2++) == c1)
      {
        if (!c1)
          s = NULL;     // reached the end of the string
        else
          s[-1] = 0;    // a delimiter found; replace it by 0
        last = s;       // remember where we leave off to continue later
        return p1;
      }
    } while (c2);
  }
}
