#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <conio.h>
#include <dos.h>

#if defined(__WATCOMC__)
// Watcom doesn't have any of these in <conio.h>:
extern void clrscr (void);
extern void gotoxy (int x, int y);
extern void textattr (int newattr);
extern void textbackground (int newcolor);
extern void textcolor (int newcolor);
extern void textmode (int newmode);
extern int wherex (void);
extern int wherey (void);
extern void _setcursortype (int cursortype);
#endif

// These are equivalent to Borland/Turbo C/C++'s and Open Watcom C/C++'s
// port I/O functions. These are defined as an alternative to
// the functions that do the same thing but differ in the API.
// It's better to use these rather than what the "standard C" libraries
// coming with the compilers provide, less conditional compilation overhead.
extern unsigned char in8 (unsigned portid);
extern void out8 (unsigned portid, unsigned char value);
extern unsigned in16 (unsigned portid);
extern void out16 (unsigned portid, unsigned value);
extern unsigned long in32 (unsigned portid);
extern void out32 (unsigned portid, unsigned long value);

size_t GetFreeHeapSize (void)
{
  size_t sz;
  void* p;
  int m, i;

  sz = 1;
  m = 0;
  for (;;)
  {
    p = malloc (sz);
    if (p == NULL)
      break;
    free (p);
    m++;
    sz <<= 1;
  }
  if (!m)
    return 0;
  m--;
  sz = ((size_t)1) << m;

  for (i=m-1; i>=0; i--)
  {
    size_t s = ((size_t)1) << i;
    p = malloc (sz | s);
    if (p != NULL)
    {
      free (p);
      sz |= s;
    }
  }

  return sz;
}

void putpixel (int x, int y, int c)
{
  union REGS inregs, outregs;
  inregs.h.ah = 0x0C;
  inregs.h.al = c;
  inregs.h.bh = 0;
  inregs.x.cx = x;
  inregs.x.dx = y;
  int86 (0x10, &inregs, &outregs);
}

int getpixel (int x, int y)
{
  union REGS inregs, outregs;
  inregs.h.ah = 0x0D;
  inregs.h.bh = 0;
  inregs.x.cx = x;
  inregs.x.dx = y;
  int86 (0x10, &inregs, &outregs);
  return outregs.h.al;
}

int main()
{
  time_t t;
  struct tm *pt;
  int x, y, c;

  printf ("free memory: %lu bytes\n", (unsigned long)GetFreeHeapSize());

  time (&t);
  pt = localtime (&t);
  printf
  (
    "Current Date and Time:\n"
    "YYYY-MM-DD HH:MM:SS | DOY DOW F\n"
    "%4u-%02u-%02u %02u:%02u:%02u | %3u %3u %d\n\n",

    pt->tm_year+1900, pt->tm_mon+1, pt->tm_mday,
    pt->tm_hour, pt->tm_min, pt->tm_sec,
    pt->tm_yday, pt->tm_wday, pt->tm_isdst
  );

  printf ("press a key...\n");
  getch();

  textattr (0x17);
  clrscr();
  gotoxy (39, 12);
  textattr (0x41);
  cprintf ("HW!\r\n");
  textattr (0x17);

  printf ("[%c][%s]\n", 'c', "string");
  printf ("[%8d][%8d]\n", 123, -123);
  printf ("[% 8d][% 8d]\n", 123, -123);
  printf ("[%+8d][%+8d]\n", 123, -123);

  printf ("[%08d][%08d]\n", 123, -123);
  printf ("[% 08d][% 08d]\n", 123, -123);
  printf ("[%+08d][%+08d]\n", 123, -123);

  printf ("[%-8d][%-8d]\n", 123, -123);
  printf ("[%- 8d][%- 8d]\n", 123, -123);
  printf ("[%-+8d][%-+8d]\n", 123, -123);

  printf ("[%d][%X][%o]\n", 32767, 32767, 32767);

  printf ("\npress a key for graphics demo. to exit graphics demo press ESC...\n");
  getch();

  textmode (0x13);

  for (y=0;y<200;y++)
    for (x=0;x<320;x++)
    {
      c = (x ^ y) & 0x7f;
      putpixel (x, y, c);
      if (getpixel (x, y) != c)
        break;
    }

  for(;;)
  {
    int k;
    k = -1;
    if (kbhit())
    {
      k = getch();
      switch (k)
      {
        case 27:
        break;

        default:
          putch (k);
        break;
      }
    }
    if (k == 27)
      break;
  }

  textmode (0x03);

  return 0;
}
